---
title: Patterns
slug: Web/SVG/Tutorial/Patterns
tags:
  - Advanced
  - SVG
  - 'SVG:Tutorial'
---
<p>{{ PreviousNext("Web/SVG/Tutorial/Gradients", "Web/SVG/Tutorial/Texts") }}</p>

<h2 id="Patterns">Patterns</h2>

<p>Patterns are arguably one of the more confusing fill types to use in SVG. They're also very powerful, so they're worth talking about and getting at least a fundamental grasp on. Like gradients, the {{SVGElement('pattern')}} element should be put in the {{SVGElement("defs")}} section of your SVG file.</p>

<pre class="brush: html">&lt;svg width="200" height="200" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;defs&gt;
    &lt;linearGradient id="Gradient1"&gt;
      &lt;stop offset="5%" stop-color="white"/&gt;
      &lt;stop offset="95%" stop-color="blue"/&gt;
    &lt;/linearGradient&gt;
    &lt;linearGradient id="Gradient2" x1="0" x2="0" y1="0" y2="1"&gt;
      &lt;stop offset="5%" stop-color="red"/&gt;
      &lt;stop offset="95%" stop-color="orange"/&gt;
    &lt;/linearGradient&gt;

    &lt;pattern id="Pattern" x="0" y="0" width=".25" height=".25"&gt;
      &lt;rect x="0" y="0" width="50" height="50" fill="skyblue"/&gt;
      &lt;rect x="0" y="0" width="25" height="25" fill="url(#Gradient2)"/&gt;
      &lt;circle cx="25" cy="25" r="20" fill="url(#Gradient1)" fill-opacity="0.5"/&gt;
    &lt;/pattern&gt;
  &lt;/defs&gt;

  &lt;rect fill="url(#Pattern)" stroke="black" width="200" height="200"/&gt;
&lt;/svg&gt;</pre>

<p>{{ EmbedLiveSample('Patterns','220','220','/files/725/SVG_Pattern_Example.png') }}</p>

<p>Inside the {{SVGElement("pattern")}} element, you can include any of the other basic shapes you've included before, and each of them can be styled using any of the styles you've learned before, including gradients and opacity. Here, we've just drawn two rectangle elements inside the pattern (which overlap, and one of which is twice the size of the other and is used to fill in the entire pattern), and one circle.</p>

<p>The confusing thing about patterns is defining a unit system and their size. In the example above, we've defined a <code>width</code> and <code>height</code> attribute on the pattern element to describe how far the pattern should go before it begins repeating itself again. There are also <code>x</code> and <code>y</code> attributes available if you want to offset the start point of this rectangle somewhere within your drawing. The reason they've been used here is described below.</p>

<p>As with the <code>gradientUnits</code> attribute used above, patterns also have an attribute, <code>patternUnits</code>, which specifies the units that these attributes will take. It defaults to <code>"objectBoundingBox"</code> as it did above, so a value of <code>1</code> is scaled to the <code>width</code>/<code>height</code> of the object you're applying the pattern to. Since, in this case, we wanted the pattern to repeat 4 times horizontally and vertically, the <code>height</code> and <code>width</code> are set to <code>0.25</code>. This means the pattern's <code>width</code>/<code>height</code> is only <code>0.25</code> of the total box size.</p>

<p>Unlike gradients, patterns have a second attribute, <code>patternContentUnits</code>, which describes the units system used inside the pattern element, on the basic shapes themselves. This attribute defaults to <code>"userSpaceOnUse"</code>, the opposite of the <code>patternUnits</code> attribute. What this means is that unless you specify one or both of these attributes (<code>patternContentUnits</code> and <code>patternUnits</code>), the shapes you draw inside your pattern are being drawn in a different coordinate system than the pattern element is using, which can make things a bit confusing when you're writing this by hand.</p>

<p>To make this work in the example above, we had to consider the size of our box (200 pixels) and the fact that we wanted the pattern to repeat itself 4 times horizontally and vertically. This means that each pattern unit was a 50×50 square. The two rects and the circle inside the pattern were then sized to fit in a 50×50 box. Anything we had drawn outside that box wouldn't have been shown. The pattern also had to be offset by 10 pixels so that it would start in the upper-left corner of our box, so the <code>x</code> and <code>y</code> attributes of the <code>pattern</code> had to be adjusted to 10÷200 = 0.05.</p>

<p>The caveat here is that if the object changes size, the pattern itself will scale to fit it, but the objects inside will not. So while we would still have 4 repeating units inside the pattern, the objects composing that pattern would remain the same size, and you end up with large areas of nothing in between them. By changing the <code>patternContentUnits</code> attribute, we can put all the elements into the same unit system:</p>

<pre class="brush: xml"> &lt;pattern id="Pattern" width=".25" height=".25" patternContentUnits="objectBoundingBox"&gt;
   &lt;rect x="0" y="0" width=".25" height=".25" fill="skyblue"/&gt;
   &lt;rect x="0" y="0" width=".125" height=".125" fill="url(#Gradient2)"/&gt;
   &lt;circle cx=".125" cy=".125" r=".1" fill="url(#Gradient1)" fill-opacity="0.5"/&gt;
 &lt;/pattern&gt;
</pre>

<p>Now, because the pattern content is in the same unit system as the pattern, we don't have to offset the box so that the pattern starts in the correct place, and if the object size was changed to a larger one, the pattern would automatically scale so that it had the same number of objects and repeats inside it. This contrasts with the <code>"userSpaceOnUse"</code> system, where if the object changes the size, the pattern would stay the same and just repeat itself more times to fill the box.</p>

<p>As a slight aside, in Gecko circles seem to have trouble drawing if their radius is set to something less than <code>0.075</code> (it is currently unknown whether this is a bug in the pattern element or not). To work around that it is probably best to avoid drawing in <code>"objectBoundingBox"</code> units unless you have to.</p>

<p>Neither of these uses is what one would normally think of when you think of a pattern. Patterns usually have a set size and repeat themselves independently of what an object's shape is. To create something like this, both the pattern and its contents must be drawn in the current userSpace, so they don't change shape if the object does:</p>

<pre class="brush: xml"> &lt;pattern id="Pattern" x="10" y="10" width="50" height="50" patternUnits="userSpaceOnUse"&gt;
   &lt;rect x="0" y="0" width="50" height="50" fill="skyblue"/&gt;
   &lt;rect x="0" y="0" width="25" height="25" fill="url(#Gradient2)"/&gt;
   &lt;circle cx="25" cy="25" r="20" fill="url(#Gradient1)" fill-opacity="0.5"/&gt;
 &lt;/pattern&gt;
</pre>

<p>Of course, this means the pattern won't scale if you change your object size later. All three of the preceding examples are shown below on a rectangle that has been slightly elongated to a <code>height</code> of <code>300px</code>, but I should note that it's not an exhaustive picture, and there are other options available depending on your application.</p>

<p><img alt="Image:SVG_Pattern_Comparison_of_Units.png" class="internal" src="/@api/deki/files/349/=SVG_Pattern_Comparison_of_Units.png"></p>

<p>{{ PreviousNext("Web/SVG/Tutorial/Gradients", "Web/SVG/Tutorial/Texts") }}</p>
